﻿using System;
using System.Globalization;
using System.Threading;
using System.Web;
using GamesStore.Web.Helpers;

namespace GamesStore.Web
{
    public static class CultureConfig
    {
        public static void Application_AcquireRequestState(object sender, EventArgs args)
        {
            var app = (HttpApplication)sender;

            CultureInfo culture = null;

            var cultureCookie = app.Context.Request.Cookies[CultureHelper.PREFFERED_CULTURE_COOKIE];
            if (cultureCookie != null)
            {
                culture = CultureHelper.GetSupportedCulture(cultureCookie.Value);
            }
            else
            {
                culture = CultureHelper.GetSupportedCulture(app.Context.Request.UserLanguages);
            }

            Thread.CurrentThread.CurrentCulture = culture;
            Thread.CurrentThread.CurrentUICulture = culture;
        }
    }
}