﻿using System.Linq;
using System.Threading;
using System.Web;
using System.Web.Mvc;
using GamesStore.Web.Helpers;

namespace GamesStore.Web.Controllers
{
    // Culture controller
    public class CultureController : Controller
    {
        public ActionResult Switch(string cultureCode, string returnUrl)
        {
            var culture = CultureHelper.GetSupportedCulture(cultureCode);

            var cultureCookie = new HttpCookie(CultureHelper.PREFFERED_CULTURE_COOKIE, culture.ToString());
            Response.Cookies.Add(cultureCookie);

            return Redirect(returnUrl);
        }


        public ActionResult CultureHeaderPartial()
        {
            var otherCultures = CultureHelper.SupportedCultures.Where(c => !c.Equals(Thread.CurrentThread.CurrentUICulture));
            return PartialView("_ChangeCultureHeader", otherCultures);
        }
    }
}