﻿using System;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Http;
using System.Web.Helpers;
using System.Security.Claims;

namespace GamesStore.Web
{
    public class Global : HttpApplication
    {
        void Application_Start(object sender, EventArgs e)
        {
            // Code that runs on application startup
            AreaRegistration.RegisterAllAreas();
            GlobalConfiguration.Configure(WebApiConfig.Register);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            MappingConfig.RegisterMappings();
            BundleConfig.Configure();

            ControllerBuilder.Current.SetControllerFactory(new DefaultControllerFactory(new GamesControllerActivator()));

            AntiForgeryConfig.UniqueClaimTypeIdentifier = ClaimTypes.Name;
        }


        void Application_AcquireRequestState(object sender, EventArgs args)
        {
            CultureConfig.Application_AcquireRequestState(sender, args);
        }
    }
}