﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Diagnostics;
using System.Text;

using Owin;
using Microsoft.Owin;
using Microsoft.AspNet.Identity.Owin;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.EntityFramework;
using Microsoft.Owin.Security.Cookies;

using GamesStore.Web.DataProviders;
using GamesStore.Entities;

[assembly:OwinStartup(typeof(GamesStore.Web.Startup))]

namespace GamesStore.Web
{
    using AppFunc = Func<IDictionary<string, object>, Task>;

    public class Startup
    {
        public void Configuration(IAppBuilder app)
        {
            app.CreatePerOwinContext(() => new GamesDbContext());
            app.CreatePerOwinContext<ApplicationUserManager>((options, context) => new ApplicationUserManager(new UserStore<User>(context.Get<GamesDbContext>())));


            app.UseCookieAuthentication(new CookieAuthenticationOptions
            {
                LoginPath = new PathString("/Account/Login"),
                AuthenticationType = DefaultAuthenticationTypes.ApplicationCookie,
            });

            app.Use(async (context, next) =>
            {
                Trace.WriteLine($"Path: {context.Request.Path}");

                await next();

                Trace.WriteLine($"Status: {context.Response.StatusCode}");
            });

            //app.UseHelloWorld();
            //app.UseWelcomePage();
        }
    }


    public class HelloWorldComponent
    {
        AppFunc _next;


        public HelloWorldComponent(AppFunc next)
        {
            _next = next;
        }


        public async Task Invoke(IDictionary<string, object> environment)
        {
            var context = new OwinContext(environment);

            var data = Encoding.UTF8.GetBytes("Hello world!");
            await context.Response.Body.WriteAsync(data, 0, data.Length);

            //await _next(environment);
        }
    }


    public static class Extensions
    {
        public static void UseHelloWorld(this IAppBuilder app)
        {
            app.Use<HelloWorldComponent>();
        }
    }
}